// 这里需要改楼层名，请和文件名及下面的floorId保持完全一致
// 楼层唯一标识符仅能由字母、数字、下划线组成，且不能由数字开头
// 推荐用法：第20层就用MT20，第38层就用MT38，地下6层就用MT_6（用下划线代替负号），隐藏3层用MT3h（h表示隐藏），等等
main.floors.MT7 = {
    "floorId": "MT7", // 楼层唯一标识符，需要和名字完全一致
    "title": "主塔 7 层", // 楼层中文名
    "name": "7", // 显示在状态栏中的层数
    "canFlyTo": true, // 该楼能否被楼传器飞到（不能的话在该楼也不允许使用楼传器）
    "canUseQuickShop": true, // 该层是否允许使用快捷商店
    "defaultGround": "ground", // 默认地面的图块ID（terrains中）
    "png": [], // 该层默认显示的所有图片；详细用法请查看文档“自定义素材”中的说明。
    // "color": [0,0,0,0.3], // 该层的默认画面色调。本项可不写（代表无色调），如果写需要是一个RGBA数组。
    // "weather": ["snow",5], // 该层的默认天气。本项可忽略表示晴天，如果写则第一项为"rain"或"snow"代表雨雪，第二项为1-10之间的数代表强度。
    // "bgm": "bgm.mp3", // 到达该层后默认播放的BGM。本项可忽略。
    "map": [ // 地图数据，需要是13x13，建议使用地图生成器来生成
        [3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3],
        [3,    87,   0,    0,    0,    0,    0,    0,    0,    1,    1,    1,    3],
        [3,    1,    1,    0,    207,  1,    82,   1,    211,  0,    1,    1,    3],
        [3,    1,    0,    207,  28,   1,    246,  1,    27,   211,  0,    1,    3],
        [3,    0,    0,    1,    1,    1,    86,   1,    1,    1,    0,    0,    3],
        [3,    0,    0,    82,   246,  86,   55,   86,   246,  82,   0,    0,    3],
        [3,    0,    1,    1,    1,    1,    86,   1,    1,    1,    1,    0,    3],
        [3,    0,    1,    31,   27,   1,    246,  1,    28,   31,   1,    0,    3],
        [3,    0,    1,    21,   31,   1,    82,   1,    31,   21,   1,    0,    3],
        [3,    0,    1,    1,    22,   22,   32,   22,   22,   1,    1,    0,    3],
        [3,    0,    0,    1,    1,    1,    83,   1,    1,    1,    0,    0,    3],
        [3,    1,    0,    0,    81,   88,   0,    0,    81,   0,    0,    1,    3],
        [3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,    3],
                    
    ],
    "firstArrive": [ // 第一次到该楼层触发的事件

    ],
    "events": { // 该楼的所有可能事件列表
        "5,5": {
            "trigger": "action", 
            "data": [
                {"type": "openDoor", "loc": [5,5]}
            ]
        }
    },
    "changeFloor": { // 楼层转换事件；该事件不能和上面的events有冲突（同位置点），否则会被覆盖
        "1,1": {"floorId": "MT8", "stair": "downFloor"},
        "5,11": {"floorId": "MT6", "stair": "upFloor"},
    },
    "afterBattle": { // 战斗后可能触发的事件列表
    },
    "afterGetItem": { // 获得道具后可能触发的事件列表

    },
    "afterOpenDoor": { // 开完门后可能触发的事件列表

    },
    "cannotMove": { // 每个图块不可通行的方向
        // 可以在这里定义每个点不能前往哪个方向，例如悬崖边不能跳下去
        // "x,y": ["up", "left"], // (x,y)点不能往上和左走

    },
}

